/****************************************************************************
** $Id: $
**
** passbroker.c
**
** Created : 030904
**
** Copyright (C) 2004  Stefano Di Paola All rights reserved.
**
** This file is part of the passbroker files package.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
**
** Contact stefano.dipaola@wisec.it if any conditions of this licensing are
** not clear to you.
**
**********************************************************************/
#include <stdio.h>
#include "php.h"
#include "php_ini.h"
#include "SAPI.h"
#include "php_main.h"
#include "ext/standard/info.h"
#include "ext/standard/php_string.h"
#include "php_globals.h"
#include "Zend/zend_ini.h"
#include <libgen.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <errno.h>

#include "passbroker.h"
#include "php_pb.h"
#ifndef DEBUG
#define dbg_printf myprintf
#else
#define dbg_printf zend_printf
#endif
extern int myprintf(const char *format, ...);

static struct caller_info *ci_head = NULL;
static struct trusted_data *td;
	

ZEND_FUNCTION (pb_get_info);

PHP_INI_MH (Onaclfile);		// handler for ini-entry "pb.dtddir"
PHP_INI_MH (Onsetdtd);		// handler for ini-entry "pb.aclfile"
PHP_INI_MH (Onsetdebug);	// handler for ini-entry "pb.debug"

function_entry pb_functions_entry[] = {
  ZEND_FE (pb_get_info, NULL)
  {NULL, NULL, NULL}
};

zend_module_entry pb_module_entry = {
  STANDARD_MODULE_HEADER,
  "pb",			/* name           */
  pb_functions_entry,	/* function_entry */
  ZEND_MINIT (pb),		/* initializator  */
  ZEND_MSHUTDOWN (pb),	/* destructor     */
  ZEND_RINIT(pb), 	        /* startup        */
  ZEND_RSHUTDOWN(pb),	       /* shutdown       */
  ZEND_MINFO(pb), 	       /* info	       */
  "0.0.1",			/* VERSION           */
  STANDARD_MODULE_PROPERTIES
};

ZEND_DECLARE_MODULE_GLOBALS (pb)
     DLEXPORT zend_module_entry *get_module (void)
{
  return &pb_module_entry;
}

void set_err ()
{
 PB_G(err)=1;
}

// Get trusted file function informations (extracted from zend_builtin_functions debug_backtrace)
static void get_caller_info ()
{
  zend_execute_data *ptr;
  char *scriptname;
  char *funcname;
  struct stat sb;
  struct caller_info *ci_tmp;
   
  if (ci_head != NULL)
  {
    free_caller_info (ci_head);
    ci_head=NULL;
  }
  ptr = EG(current_execute_data);
  //does it must be (un)commented?
  //ptr = ptr->prev_execute_data;

  while (ptr)
    {
      if (ptr->op_array)
      {
        //scriptname = zend_get_executed_filename(TSRMLS_C);
        scriptname = ptr->op_array->filename;
      }
      else
      {
        scriptname = "~"; 
      }

      funcname = ptr->function_state.function->type != ZEND_OVERLOADED_FUNCTION ? ptr->function_state.function->common.function_name : get_active_function_name (TSRMLS_C);	/* "OVERLOADED_FUNCTION" */
      dbg_printf ("%s %s -------------\n", scriptname, funcname);
      if (funcname == NULL)
	funcname = "~";
	 int  uid=0 ;
	int gid=0 ;
	if(strcmp(scriptname,"~")){
	if (VCWD_STAT(scriptname, &sb) < 0) {
		if (( CHECKUID_NO_ERRORS) == 0) {
			php_error_docref(NULL TSRMLS_CC, E_WARNING, "Unable to access %s", scriptname);
		}
		uid=gid=-1;
	}
	}else{
	uid=gid=-1;
	}
	 uid = sb.st_uid;
	 gid = sb.st_gid;
	ci_tmp=new_caller_info(scriptname,uid,gid, funcname);
	if(ci_head==NULL)
		ci_head=ci_tmp;
	else
         ci_head=add_caller_info(ci_head , ci_tmp );
      ptr = ptr->prev_execute_data;
    }
}


ZEND_FUNCTION (pb_get_info)
{
  char *tidName;
  long tidName_len;
  char *sidName;
  long sidName_len;
  pval *tmp_arr;
  struct secret_info *si_head=NULL;
  if (ZEND_NUM_ARGS () != 2)
  {
    WRONG_PARAM_COUNT;
  }
  
  if (zend_parse_parameters(ZEND_NUM_ARGS ()TSRMLS_CC, "ss", &tidName, &tidName_len, &sidName, &sidName_len) == FAILURE)
  {
    return;
  }

// In ingresso si ha l'identificativo (string) o nulla
// Controllo script, funzione chiamante, owner group
// se va tutto bene ritorno un array associativo chiave=>valore
//Considerare l'eventualit di controllare anche uid gid del processo e owner group del
// file con le acl.
if(PB_G(err))
{
   zend_error(E_ERROR,"%s",theerror);
    
}else{

// Get trusted file function informations 
  get_caller_info();
 zend_printf("td_ %p %p %p\n",&td, td, *td);
 if (PB_G(debug)==DBG_LEARNACL)
 {
    int level=0;
    struct caller_info *ci_tmp;
    struct stat statb;
    extern int errno;
    ci_tmp = ci_head;
    FILE *fh;
    
    if(VCWD_LSTAT ("/tmp/trust.xml" , &statb)!=0 && errno!=ENOENT)
    {
     zend_error (E_CORE_WARNING,"sorry LEARN_ACL can't be set.\n");
         RETURN_EMPTY_STRING();     
    }
    if ( !S_ISREG (statb.st_mode))
      {
    	 zend_error (E_CORE_WARNING,"sorry LEARN_ACL can't be set.\n");
         RETURN_EMPTY_STRING();
      }
     fh=fopen("/tmp/trust.xml","a");
    if(fh==NULL)
    {
     zend_error (E_CORE_WARNING,"sorry\n");
     RETURN_EMPTY_STRING();
    }
 	//zend_error (E_CORE_WARNING,"<Secret sid=\"%s\">\n%s\n%s",sidName,
 //	"<Info name=\"name\"  value=\"value\" />" ,"<PHPolicy>\n" );
   while (ci_tmp)
      {
 	level++;
        fprintf (fh,"<FromCallerScript ScriptName=\"%s\" ScriptFunctionName=\"%s\"  ScriptOwnerUId=\"%d\" ScriptOwnerGId=\"%d\" ", ci_tmp->file_name, ci_tmp->func_name , ci_tmp->file_name_uid, ci_tmp->file_name_gid);
 	ci_tmp = ci_tmp->next;
        fprintf (fh,"%s",(ci_tmp?">\n":"/>\n"));
      }
      level--;
  while(level--){
    fprintf (fh,"</FromCallerScript>\n");
   }
   fflush(fh);
   fclose(fh);
   // zend_error (E_CORE_WARNING,"</PHPolicy>\n");
 }
 
 if( PB_G(debug)==DBG_GENERATEACL)
 {
    int level=0;
    struct caller_info *ci_tmp;
    ci_tmp = ci_head;
 	zend_printf ("<Secret sid=\"%s\">\n%s\n%s",sidName,
 	"<Info name=\"name\"  value=\"value\" />" ,"<PHPolicy>\n" );
   while (ci_tmp)
      {
 	level++;
        zend_printf ("<FromCallerScript ScriptName=\"%s\" ScriptFunctionName=\"%s\"  ScriptOwnerUId=\"%d\" ScriptOwnerGId=\"%d\" ", ci_tmp->file_name, ci_tmp->func_name , ci_tmp->file_name_uid, ci_tmp->file_name_gid);
 	ci_tmp = ci_tmp->next;
 	  zend_printf ("%s",(ci_tmp?">\n":"/>\n"));
      }
      level--;
  while(level--){
    zend_printf ("</FromCallerScript>\n");
   }
    zend_printf ("</PHPolicy>\n");
}

if(td!=NULL && (PB_G(debug)==DBG_NONE ||  PB_G(debug)==DBG_LEARNACL)){
  struct caller_info *ci_tmp;
  struct secret_info *si_tmp;
  
  ci_tmp = ci_head;
  
  while (ci_tmp)
    {
      dbg_printf ("CALLING FUNC:%s\nFILNAME: %s\n", ci_tmp->func_name,  ci_tmp->file_name);
      ci_tmp = ci_tmp->next;
    }
 
     
   si_head=get_secret(td,ci_head,tidName,sidName ); 
   si_tmp=si_head;
 
    while (si_tmp)
      {
 	dbg_printf ("mysecret:%s\n",si_tmp->sid );
	print_assoc_secret(si_tmp->secret);
 	si_tmp = si_tmp->next;
      }
     dbg_printf ("FINE\n");
}else if(td==NULL) {
    	zend_error(E_ERROR,"Sorry no Trusted data!\n");
	RETURN_EMPTY_STRING();
    }
}
 
if(si_head)
 {
    struct secret_info *si_tmp;
  array_init(return_value);
  si_tmp=si_head;
  while(si_tmp)
  {
    struct assoc_secret *secret=si_tmp->secret;
    char *ass_idx;
    MAKE_STD_ZVAL(tmp_arr);
    array_init(tmp_arr);
    while(secret){
     add_assoc_string(tmp_arr,secret->name,secret->value,1);
     secret=secret->next;
    }
    dbg_printf("il TID %s\n",si_tmp->tid);

    ass_idx=concat( si_tmp->tid ,"_",0);

    dbg_printf("il TID %s ass_idx %s\n",si_tmp->tid,ass_idx);

    add_assoc_zval(return_value,concat(ass_idx, si_tmp->sid  ,0),tmp_arr);
    efree(ass_idx);
    si_tmp=si_tmp->next;
  }
  free_secret_info(si_head);
  
 } 
else
 {
   if( PB_G(debug)==DBG_GENERATEACL)
   {
      int level=0;
      struct caller_info *ci_tmp;
      ci_tmp = ci_head;

 	  zend_printf ("<Secret sid=\"%s\">\n%s\n%s",sidName,
 	  "<Info name=\"name\"  value=\"value\" />" ,"<PHPolicy>\n" );
     while (ci_tmp)
	{
 	  level++;
          zend_printf ("<FromCallerScript ScriptName=\"%s\" ScriptFunctionName=\"%s\"  ScriptOwnerUId=\"%d\" ScriptOwnerGId=\"%d\" ", ci_tmp->file_name, ci_tmp->func_name , ci_tmp->file_name_uid, ci_tmp->file_name_gid);
 	  ci_tmp = ci_tmp->next;
 	    zend_printf ("%s",(ci_tmp?">\n":"/>\n"));
	}
	level--;
    while(level--){
      zend_printf ("</FromCallerScript>\n");
     }
      zend_printf ("</PHPolicy>\n");
    } 
   RETURN_EMPTY_STRING();}
}

PHP_RINIT_FUNCTION(pb) {
 return SUCCESS; 
}

PHP_RSHUTDOWN_FUNCTION(pb) { 
//free_trusted_data(td);
return SUCCESS; 
}

PHP_MINFO_FUNCTION(pb) {
   php_info_print_table_start(); 
   php_info_print_table_header(2, "PassBroker support", "enabled"); 
   php_info_print_table_end(); 
   DISPLAY_INI_ENTRIES(); 
}
     /* {{{ PHP_INI */
PHP_INI_BEGIN ()
PHP_INI_ENTRY ("pb.dtddir",  "/etc/pb/dtds",      PHP_INI_SYSTEM, Onsetdtd) 
PHP_INI_ENTRY ("pb.aclfile", "/etc/pb/pbacl.xml", PHP_INI_SYSTEM, Onaclfile) 
PHP_INI_ENTRY ("pb.debug", "None", PHP_INI_PERDIR, Onsetdebug) 
PHP_INI_END ()
  /* }}} */
 
ZEND_MINIT_FUNCTION (pb)
{
  REGISTER_INI_ENTRIES ();
  return SUCCESS;
}

ZEND_MSHUTDOWN_FUNCTION (pb)
{
 
  UNREGISTER_INI_ENTRIES ();
system("rm -f /tmp/Mspb;touch /tmp/Mspb");
	  return SUCCESS;
}

char *concat(char *str1,char *str2,int dup)
{
  char *dest;
  int str1len;
  int str2len;
  str1len=strlen(str1);
  str2len=strlen(str2);
  dest = (char * )emalloc((str1len+str2len+1)*sizeof(char));
  memset(dest,'\0',(str1len+str2len+1));
  strncpy(dest,str1,str1len );
  strncat(dest,str2,str2len );
  dest[(str1len+str2len)]='\0';
  if(dup)
  {
    efree(str1);
    str1=dest;
  }
  return dest;
}
 /* {{{ PHP_INI_MH
  */
PHP_INI_MH (Onsetdtd)
{
 char *thefile;
 char *thedir;
  struct stat statb;
 if (new_value == NULL)
    {
      PB_G (dtddir) = estrndup ("/etc/pb/dtds/", 12);
    }
  else
    {
     
       if (VCWD_LSTAT ( new_value, &statb) < 0){
	  // if non esiste il file setta un flag che verra' controllato alla chiamata della funzione.
	  PB_G (dtddir) = NULL;
	  PB_G (dtdfile)=NULL;
          zend_error(E_WARNING,"Sorry dtddir %s does not exists\n",  new_value);
	  return FAILURE;
	}
       if (S_ISLNK(statb.st_mode)|| !S_ISDIR(statb.st_mode)){
         // if non esiste il file setta un flag che verra' controllato alla chiamata della funzione.
         PB_G (dtdfile)=NULL;
         PB_G (dtddir) = NULL;
         zend_error(E_WARNING,"Sorry dtddir %s is not a dir\n",  new_value);
         return FAILURE;
       }
       thedir = estrdup (new_value);
       if(thedir[strlen(thedir)-1]!='/')
        thedir=concat(thedir,"/",1);
       PB_G (dtddir) =  estrdup( thedir );
     
    }
    
    thefile=concat(PB_G (dtddir), PB_DTDNAME,0);
      if (VCWD_LSTAT ( thefile, &statb) < 0){
	  // if non esiste il file setta un flag che verra' controllato alla chiamata della funzione.
	  PB_G (dtddir) = NULL;
	  PB_G (dtdfile)=NULL;
          zend_error(E_WARNING,"sorry dtdfile %s does not exists\n",thefile );
	  return FAILURE;
	}
      if (S_ISLNK(statb.st_mode)|| !S_ISREG(statb.st_mode)){
         // if non esiste il file setta un flag che verra' controllato alla chiamata della funzione.
         PB_G (dtdfile)= NULL;
         PB_G (dtddir) = NULL;
         zend_error(E_WARNING,"sorry dtdfile %s is not a regular file\n",thefile );
         return FAILURE;
       }

     PB_G (dtdfile)=  estrdup(thefile);
 return SUCCESS;
}
 
/* prende in ingresso il file con le acl. 
considerare l'eventualit di controllare i permessi
in lettura scrittura etc (st_mode)

--------------------
Oppure prende il username e la pass
piu'  la select x il dbms.
*/
/* {{{ PHP_INI_MH
 */
PHP_INI_MH (Onaclfile)
{
  char *thefile;
  char *xmlfile;
  struct stat statb;
  char *fullpathfile;
  int nb=0;
  ci_head = NULL;
  if( !PB_G(err) ||  PB_G(dtdfile)){
  if (new_value == NULL)
  {
    PB_G (aclfile) = estrndup ("/etc/pb/pbacl.xml", 12);
  }
  else
  {

      thefile = basename (new_value);
      int fullpath_len = strlen (PB_G(dtddir)) + strlen (thefile) +1;
      fullpathfile = (char *) emalloc (fullpath_len * sizeof (char));
      sprintf (fullpathfile, "%s/%s", ACLDIR, thefile);
      fullpathfile[fullpath_len] = '\0';
     if (VCWD_LSTAT (fullpathfile, &statb) < 0)
	{
	  // if non esiste il file setta un flag che verra' controllato alla chiamata della funzione.
	  PB_G (aclfile) = estrdup (fullpathfile);
         zend_error(E_WARNING,"sorry xmlfile %s does not exists\n",fullpathfile  );
	 set_err();
	   
	  return FAILURE;
	}
      if ( !S_ISREG (statb.st_mode))
	{
	  // if non esiste il file setta un flag che verra' controllato alla chiamata della funzione.
	  PB_G (aclfile) = NULL;
         zend_error(E_WARNING,"sorry xmlfile %s is not a regular file\n",fullpathfile  );
	   set_err();
	return FAILURE;
	}
      PB_G (aclfile) = estrdup (fullpathfile);
    }
  xmlfile = (char *) emalloc ((statb.st_size+1) * sizeof (char));
  memset(xmlfile,'\0',(statb.st_size+1) * sizeof (char));

  FILE *fh = VCWD_FOPEN ( PB_G(aclfile), "r");
  if (fh == NULL)
    {
        efree ( xmlfile);
        zend_error(E_WARNING,"sorry xml %s does not exists\n",PB_G(aclfile)  );
   	set_err();
        return FAILURE;
    }
 nb= fread ((char *) xmlfile, sizeof (char), statb.st_size, fh);
  fclose (fh);
   
  td=NULL;
  td = parsexml(xmlfile,PB_G(dtdfile)); 
   
  if(td==NULL){
         zend_error(E_WARNING,"sorry  parse error in aclfile %s\n Byte len=%d\n%s\n", PB_G(aclfile),nb,  xmlfile);
          PB_G(err)=1;
  	return SUCCESS;
  }
  }else{
           zend_error(E_WARNING,"sorry dtdfile %s does not exists\n", PB_G(dtdfile) );
           set_err();
  	return FAILURE;
	   
  }
  efree(xmlfile);
  return SUCCESS;
}
PHP_INI_MH (Onsetdebug)
{
  if (new_value == NULL)
  {
    PB_G (debug) = DBG_NONE;
  }
  else
  {
   if(!strncasecmp(new_value,"generateacl",11))
    {
     PB_G (debug)=DBG_GENERATEACL;
    } else if(!strncasecmp(new_value,"learnacl",8)){
    
      PB_G (debug)=DBG_LEARNACL;
   }else   {
     PB_G (debug)=DBG_NONE;
    }
  }
        
 return SUCCESS;

}
