#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
//#include <regex.h>
#include "passbroker.h"
#ifdef PHP_MOD
#include "php.h"
#include "php_ini.h"
#include "SAPI.h"
#include "php_main.h"
#include "ext/standard/info.h"
#include "ext/standard/php_string.h"
#include "php_globals.h"
#include "Zend/zend_ini.h"
#endif

#ifndef DEBUG
#define zend_printf myprintf
#endif
int myprintf(const char *format, ...){return 0;}

//Populate caller_info 
struct caller_info *new_caller_info (char *scriptname,int file_name_uid,int file_name_gid,char *funcname)
{
   struct caller_info *ci_new;
    ci_new=(struct caller_info *)  malloc(sizeof(struct  caller_info));
  if(scriptname!=NULL)
   ci_new->file_name=strdup(scriptname); 
   else
    ci_new->file_name=NULL;
  if( funcname!=NULL)
    ci_new->func_name= strdup(funcname);
   else
    ci_new->func_name=NULL;
  ci_new->file_name_uid=file_name_uid;
  ci_new->file_name_gid=file_name_gid;
  ci_new->next=NULL;
   return ci_new;
}

//Populate caller_info
struct caller_info * add_caller_info( struct caller_info *ci_head,struct caller_info *ci_node)
{
    struct caller_info *ci_tmp;
   if(ci_head==NULL)
   {
     ci_head=ci_node;
   
   }
   else{
    ci_tmp=ci_head;
    ci_head=ci_node;
    ci_head->next=ci_tmp;
   }
     return  ci_head;
}

void print_caller_info(struct caller_info *ci_head)
{
  struct caller_info *ci_tmp2;
  ci_tmp2=ci_head;
  while(ci_tmp2!=NULL)
  {
  
   #ifdef PHP_MOD
  zend_printf( "Caller info: %s %d %d %s \n",ci_tmp2->file_name,ci_tmp2->file_name_uid,ci_tmp2->file_name_gid ,ci_tmp2->func_name  );
 #else 
   printf( "Caller info: %s %d %d %s \n",ci_tmp2->file_name,ci_tmp2->file_name_uid,ci_tmp2->file_name_gid ,ci_tmp2->func_name  );
 #endif
    ci_tmp2=ci_tmp2->next;
   #ifdef PHP_MOD
     zend_printf("Caller info next: %x\n",ci_tmp2);
 #else 
     printf("Caller info next: %x\n",ci_tmp2);
 #endif
  }
}
void free_caller_info(struct caller_info *ci)
{
 struct caller_info *ci_tmp;
 struct caller_info *ci_tmp2;
 ci_tmp=ci;
 while(ci_tmp){
 	ci_tmp2=ci_tmp;
	
	if(ci_tmp2->file_name)
	  free(ci_tmp2->file_name);
	
	if(ci_tmp2->func_name)
	  free(ci_tmp2->func_name);
	  
	ci_tmp=ci_tmp2->next;
	free(ci_tmp2);
	ci_tmp2=NULL;
 }
}

//Populate  assoc_secret
struct assoc_secret *  new_assoc_secret (char *name,char *value)
{
   struct assoc_secret *as_new;
    as_new=(struct assoc_secret *)  malloc(sizeof(struct  assoc_secret));
  if(name!=NULL)
   as_new->name=strdup(name); 
   else
    as_new->name=NULL;
  if( value!=NULL)
    as_new->value= strdup(value);
   else
    as_new->value=NULL;
  as_new->next=NULL;
   return as_new;
}
//Populate caller_info
struct assoc_secret * add_assoc_secret( struct assoc_secret *as_head,struct assoc_secret *as_node)
{
    struct assoc_secret *as_tmp;
   if(as_head==NULL)
   {
     as_head=as_node;
   }
   else{
    as_tmp=as_head;
    as_head=as_node;
    as_head->next=as_tmp;
   }
     return  as_head;
}

void print_assoc_secret(struct assoc_secret *as_head)
{
  struct assoc_secret *as_tmp2;
  as_tmp2=as_head;
  while(as_tmp2!=NULL)
  {
  
   #ifdef PHP_MOD
  zend_printf( "ASS Secret info: %s  %s \n",as_tmp2->name,as_tmp2->value);
 #else 
    printf( "ASS Secret info: %s  %s \n",as_tmp2->name,as_tmp2->value);
 #endif
    as_tmp2=as_tmp2->next;
   #ifdef PHP_MOD
     zend_printf("ASS Secret info next: %x\n",as_tmp2);
 #else 
    printf("ASS Secret info next: %x\n",as_tmp2);
 #endif
  }
}
struct assoc_secret *copy_assoc_secret(struct  assoc_secret *as_head)
{
  struct assoc_secret *as_tmp2;
  struct assoc_secret *as_head2=NULL;
  struct assoc_secret *as_tmp3=NULL;
  as_tmp2=as_head;
  while(as_tmp2!=NULL)
  {
    as_tmp3=new_assoc_secret(as_tmp2->name,as_tmp2->value);
    if(as_head2==NULL)
     as_head2=as_tmp3;
     else
     as_head2=add_assoc_secret(as_head2,as_tmp3);
    as_tmp2=as_tmp2->next;
     
  }
  return as_head2;
}
void free_assoc_secret(struct assoc_secret *as)
{
 struct assoc_secret *as_tmp;
 struct assoc_secret *as_tmp2;
 as_tmp=as;
 while(as_tmp){
	as_tmp2=as_tmp;
	
	if(as_tmp2->name)
	{
	  memset(as_tmp2->name,0,strlen(as_tmp2->name));
	  free(as_tmp2->name);
	}
	if(as_tmp2->value)
	{ 
	  memset(as_tmp2->value,0,strlen(as_tmp2->value));
	   free(as_tmp2->value);
	}
	as_tmp=as_tmp2->next;
	free(as_tmp2);
	as_tmp2=NULL;
 }
}

struct caller_info *reverse_caller_info(struct caller_info *ci_head)
{
  struct caller_info *ci_tmp2;
  struct caller_info *ci_head2=NULL;
  struct caller_info *ci_tmp3=NULL;
  ci_tmp2=ci_head;
  while(ci_tmp2!=NULL)
  {
    ci_tmp3=new_caller_info(ci_tmp2->file_name,ci_tmp2->file_name_uid,ci_tmp2->file_name_gid ,ci_tmp2->func_name);
    if(ci_head2==NULL)
     ci_head2=ci_tmp3;
     else
     ci_head2=add_caller_info(ci_head2,ci_tmp3);
    ci_tmp2=ci_tmp2->next;
     
  }
  if(ci_head!=NULL)
    free_caller_info(ci_head );
 // print_caller_info(ci_app);
  ci_head=ci_head2;

  return ci_head2;
}

struct caller_info *copy_caller_info(struct caller_info *ci_head)
{
  struct caller_info *ci_tmp;
   struct caller_info *ci_app=NULL;
  struct caller_info *ci_tail=NULL;
  struct caller_info *ci_pretail=NULL;
     ci_tail=ci_head;
   
  while(ci_head!=ci_pretail)
  {
    while(ci_tail)
    {
     if( ci_head==ci_pretail)
     {break;}
     if(ci_tail->next==NULL ||ci_tail->next==ci_pretail  )
     {
      ci_pretail=ci_tail;
    //   zend_printf("trovata fine %s\n",ci_tail->file_name);
       ci_tmp=new_caller_info( ci_tail->file_name,ci_tail->file_name_uid,ci_tail->file_name_gid,ci_tail->func_name);
      if(ci_app==NULL)
      ci_app=ci_tmp;
      else
      ci_app=add_caller_info(ci_app,ci_tmp);
      ci_tail=ci_head;
      break;
     }
    // zend_printf("NON trovata fine %s\n",ci_tail->file_name);
     ci_tail=ci_tail->next;
   }
 }
   
 
  return  ci_app;
}


void print_trusted_secret(struct trusted_secret *ts_head)
{
  struct trusted_secret *ts_tmp;
  ts_tmp=ts_head;
  while(ts_tmp)
  {
#ifdef PHP_MOD
     zend_printf("Trusted Secret: %s %x %x\n",ts_tmp->sid,ts_tmp->secret_info,ts_tmp->next );
 #else 
      printf("Trusted Secret: %s %x %x\n",ts_tmp->sid,ts_tmp->secret_info,ts_tmp->next );   
#endif
     print_assoc_secret(ts_tmp->secret_info );
     print_caller_info(ts_tmp->ci_acl);
    ts_tmp=ts_tmp->next;
  }
}
void print_trusted_data(struct trusted_data *td_head)
{
  struct trusted_data *td_tmp;
  td_tmp=td_head;
#ifdef PHP_MOD
     zend_printf("Trust data: \n");
 #else 
      printf("Trust data: \n");
#endif
  while(td_tmp)
  {
#ifdef PHP_MOD
     zend_printf("Trust data: %s %x\nBegin caller Info\n",td_tmp->tid,td_tmp->next );
 #else 
     printf("Trust data: %s %x\nBegin caller Info\n",td_tmp->tid,td_tmp->next );
 #endif
    print_caller_info(td_tmp->ci_acl);
#ifdef PHP_MOD
     zend_printf("End caller Info\n" );
 #else 
     printf("End caller Info\n" );
 #endif
#ifdef PHP_MOD

    zend_printf("Begin Trusted Secret\n");
#endif
     print_trusted_secret(td_tmp->tsecret);
#ifdef PHP_MOD
    zend_printf("End Trusted Secret\n");
 #else 
    printf("End Trusted Secret\n");
#endif
    
    td_tmp=td_tmp->next;
  }
}


//Populate trusted secret
struct trusted_secret * add_trusted_secret( struct trusted_secret *ts_head,struct trusted_secret  *ts_node)
{
    struct trusted_secret *ts_tmp;
   if(ts_head==NULL)
   {
     ts_head=ts_node;
   
   }
   else{
    ts_tmp=ts_head;
    ts_head=ts_node;
    ts_head->next=ts_tmp;
   }
     return ts_head;
}

//Populate trusted_secret
 struct trusted_secret * new_trusted_secret(char *sid,struct assoc_secret *secret_info,struct caller_info *ci)
{
   struct trusted_secret *ts_new;
   
   ts_new=(struct trusted_secret *) malloc(sizeof(struct  trusted_secret));
  
   if(sid!=NULL)
   	ts_new->sid= strdup(sid);
   else
   	ts_new->sid=NULL;
    
   if( secret_info!=NULL)
   	ts_new->secret_info =secret_info;
   else
   	ts_new->secret_info=NULL;
   if(ci!=NULL)
   ts_new->ci_acl=ci;
   else
   ts_new->ci_acl=NULL;
    
   ts_new->next=NULL;
   return  ts_new;
}

void free_trusted_secret(struct trusted_secret *ts)
{
 struct trusted_secret *ts_tmp;
 struct trusted_secret *ts_tmp2;
 ts_tmp=ts;
 while(ts_tmp){
 	ts_tmp2=ts_tmp;
	if(ts_tmp2->sid!=NULL)
		free(ts_tmp2->sid);
	if(ts_tmp2->secret_info !=NULL)
		free_assoc_secret(ts_tmp2->secret_info);
	if(ts_tmp2->ci_acl !=NULL)
        	free_caller_info(ts_tmp->ci_acl);
	ts_tmp=ts_tmp2->next;
	free(ts_tmp2);
	ts_tmp2=NULL;
 }
}

//Populate trusted data
 struct trusted_data  * add_trusted_data( struct trusted_data *td_head,struct trusted_data  *td_node)
{
    struct trusted_data *td_tmp;
   if(td_head==NULL)
   {
     td_head=td_node;
   
   }
   else{
    td_tmp=td_head;
    td_head=td_node;
    td_head->next=td_tmp;
   }
     return td_head;
}

//Populate trusted_data
struct trusted_data * new_trusted_data( char *tid,struct trusted_secret *ts_head,struct caller_info *ci_head )
{
   struct trusted_data *td_new;
     
   td_new=(struct   trusted_data*) malloc( sizeof(struct trusted_data  ) );
  
   if(tid!=NULL)
   	td_new->tid= strdup(tid);
   else
   	td_new->tid=NULL;
   td_new->tsecret= ts_head;
   td_new->ci_acl= ci_head;
   td_new->next=NULL;
   return td_new;   
}

void free_trusted_data(struct trusted_data *td)
{
  struct trusted_data *td_tmp;
  struct trusted_data *td_tmp2;
  td_tmp=td;
  while(td_tmp){
	td_tmp2=td_tmp;
	if(td_tmp2->tid!=NULL)
	free( td_tmp2->tid);
	if(td_tmp2->tsecret!=NULL)
	free_trusted_secret(td_tmp2->tsecret);
	
	if(td_tmp2->ci_acl !=NULL)
	free_caller_info(td_tmp2->ci_acl);
	td_tmp=td_tmp2->next;
	free(td_tmp2);
	td_tmp2=NULL;
  }
}

//Populate trusted_data
struct secret_info *new_secret_info(char *tid ,char *sid ,struct assoc_secret *sinfo)
{
   struct secret_info *si_new;
     
   si_new=(struct   secret_info*) malloc( sizeof(struct secret_info  ) );
  
   if(sinfo!=NULL)
   	si_new->secret= copy_assoc_secret( sinfo );
   else
   	si_new->secret=NULL;

   if(sid!=NULL)
   	si_new->sid= strdup(sid);
   else
   	si_new->sid=NULL;
   if(tid!=NULL)
   	si_new->tid= strdup(tid);
   else
   	si_new->tid=NULL;
    si_new->next=NULL;
   return si_new;   
}
struct  secret_info * add_secret_info( struct  secret_info *si_head,struct  secret_info  *si_node)
{ 
    struct secret_info  *si_tmp;
   if(si_head==NULL)
   {
     si_head=si_node;    
   }
   else{
    si_tmp=si_head;
    si_head=si_node;
    si_head->next=si_tmp;
   }
     return si_head;
}
 
void free_secret_info(struct secret_info *si)
{
  struct secret_info *si_tmp;
  struct secret_info *si_tmp2;
  si_tmp=si;
  while(si_tmp){
	si_tmp2=si_tmp;
	if(si_tmp2->secret)
	free_assoc_secret(si_tmp2->secret);
	if(si_tmp2->sid)
	free(si_tmp2->sid);
	si_tmp=si_tmp2->next;
	free(si_tmp2);
	si_tmp2=NULL;
  }
}
int match(char *pattern,const char *string )
{
    int    status;
    regex_t    re;


    if (regcomp(&re, pattern, REG_EXTENDED|REG_NOSUB) != 0) {
        zend_printf("checked %s %s: KO! \n",pattern,string);
        return(0);      /* Report error. */
    }
   
    status = regexec(&re, string, (size_t) 0, NULL, 0);
    regfree(&re);
    if (status != 0) {
         zend_printf("checked %s %s: KO! \n",pattern,string);
        return(0);      /* Report error. */
    }
    zend_printf("checked %s %s: OK! \n",pattern,string);
    return(1);
}

int compare_calling_info(struct caller_info *trusted_ci,struct  caller_info *untrusted_ci)
{
  int same=0;
  //if trusted calling_info is null means that everyone can use this trust.
  if(trusted_ci==NULL)
    return 0;
   while(trusted_ci){
	if(untrusted_ci)
	{
	 #ifdef PHP_MOD
	   zend_printf ("trust uid %d untrust uid %d  \n",trusted_ci->file_name_uid , untrusted_ci->file_name_uid );
	   zend_printf ("trust filename %s untrust filename %s \n",trusted_ci->file_name , untrusted_ci->file_name );
	  zend_printf ("trust funcname %s untrust funcname %s \n",trusted_ci->func_name , untrusted_ci->func_name );
	 #endif
	    
	 // in realta' dovrei controllare se trusted_ci (il trusted) ha il func_name a null. se si basta il
	  // nome  del file_name.
		if( trusted_ci->file_name_uid==untrusted_ci->file_name_uid 
		&& trusted_ci->file_name_gid==untrusted_ci->file_name_gid 
		&&  match(trusted_ci->file_name,untrusted_ci->file_name)  && 
		(trusted_ci->func_name==NULL ||  match(trusted_ci->func_name,untrusted_ci->func_name))){
		       // zend_printf("got positive for %s %s %s %s\n",trusted_ci->file_name,untrusted_ci->file_name,trusted_ci->func_name,untrusted_ci->func_name);
	  		trusted_ci=trusted_ci->next;
	  		untrusted_ci=untrusted_ci->next;
	  		same=1;	
		}
		else
		  return 1;
	}else
	  return 1;
   }
   if(same)
    return 0;
   else
   return 1;
}

struct secret_info   *get_trusted_secret( struct secret_info *si_head,struct trusted_secret *ts_head,struct caller_info *called_ci,char *tid,char *sid)
{
  int found=0;
 struct secret_info *si_tmp=NULL;
 #ifdef PHP_MOD
 zend_printf ("  %x\n", si_head );
  #endif  		 
 if(ts_head!=NULL)
 {
     struct trusted_secret *ts_tmp;
     int sid_len=strlen(sid);
     ts_tmp=ts_head;
     while(ts_tmp){
       
	    #ifdef PHP_MOD
	 zend_printf ("sid %s reqsid %s \n",ts_tmp->sid ,sid  );
      	 #endif
	    if(sid==NULL || (!strncmp(ts_tmp->sid,sid,MIN(strlen(ts_tmp->sid),sid_len))))
   	    {
 	   	  //TROVATO IL TID CORRISPONDENTE 
		  //CONTROLLA SE CI SONO POLICY GENERICHE;
		  // SE SI E CORRISPONDE O NO
		  // 	CERCA NEI trusted_secret
		  //      se sid !=NULL
		  //       se !strncmp(ts_->sid,sid)   
		  //
                  if(ts_tmp->ci_acl==NULL || (!compare_calling_info(ts_tmp->ci_acl,called_ci))){
		      found=1;
		   #ifdef PHP_MOD
		   zend_printf ("2sid %s reqsid %s %x\n",ts_tmp->sid ,sid ,si_head );
    		   #endif
		       si_tmp=new_secret_info(tid, ts_tmp->sid,ts_tmp->secret_info);
		        if(si_head==NULL)
		       si_head=si_tmp;
		       else
		       si_head=add_secret_info(si_head,si_tmp);
		  }
	   }
	   ts_tmp=ts_tmp->next;
     }
 }
 return si_head;
}

struct secret_info *get_secret(struct trusted_data *td_head,struct caller_info *called_ci,char *tid,char *sid)
{
  
  // se td_head!=NULL
  //     se tid!=NULL
  //       se si
 struct secret_info *si_head;
   si_head=NULL;
 if(td_head!=NULL)
 {
     struct trusted_data *td_tmp;
     
     int tid_len=strlen(tid);
     td_tmp=td_head;
     while(td_tmp){
            //  se il tid argomento della pb_get_info e' nullo o coincide con il tid della acl corrente
	    if(tid==NULL || (!strncmp(td_tmp->tid,tid,MIN(strlen(td_tmp->tid),tid_len))))
	    {
     		  //TROVATO IL TID CORRISPONDENTE 
		  //CONTROLLA SE CI SONO POLICY GENERICHE;
		  // SE SI E CORRISPONDE O NO
		  // 	CERCA NEI trusted_secret
		  //      se sid !=NULL
		  //       se !strncmp(ts_->sid,sid)   
		  // 
		  #ifdef PHP_MOD
		     zend_printf ("BEGIN TID\n"  );
                 #endif
		  print_trusted_data(td_tmp);     
		  #ifdef PHP_MOD
		 zend_printf ("END TID\n" );
         zend_printf ("tid %s reqtid %s\n",td_tmp->tid ,tid );
                #endif
	   	  if(td_tmp->ci_acl==NULL || (!compare_calling_info(td_tmp->ci_acl,called_ci))){ 
		  
		   #ifdef PHP_MOD
		  zend_printf ("3tid %s 3reqtid %s \n",td_tmp->tid ,tid );
		   #endif
		      si_head=get_trusted_secret( si_head,td_tmp->tsecret,called_ci,td_tmp->tid,sid);
		  }
	   }
	   td_tmp=td_tmp->next;
     }
 }
 return si_head; 
}
