/*
  +----------------------------------------------------------------------+
  |                                                        |
  +----------------------------------------------------------------------+
  |                      |
  +----------------------------------------------------------------------+
  |   |
  |   |
  |   |
  |   |
  |   |
  |   |
  |   |
  +----------------------------------------------------------------------+
  | Author: Stefano Di Paola <stefano.dipaola@wisec.it>                  |
  +----------------------------------------------------------------------+

 
*/

#ifndef PHP_PB_H
#define PHP_PB_H

extern zend_module_entry pb_module_entry;
#define phpext_pb_ptr &pb_module_entry

#ifdef PHP_WIN32
#define PHP_PB_API __declspec(dllexport)
#else
#define PHP_PB_API
#endif

#ifdef ZTS
#include "TSRM.h"
#endif

PHP_MINIT_FUNCTION(pb);
PHP_MSHUTDOWN_FUNCTION(pb);
PHP_RINIT_FUNCTION(pb);
PHP_RSHUTDOWN_FUNCTION(pb);
PHP_MINFO_FUNCTION(pb);



ZEND_BEGIN_MODULE_GLOBALS(pb)
	char *aclfile;
	char *dtdfile,*dtddir;
	char *file;
	int err;
	int debug;
	int use_regex;
ZEND_END_MODULE_GLOBALS(pb)

#define  PB_DTDNAME "PassBroker.dtd"
#define  DBG_NONE 0
#define  DBG_GENERATEACL 1
#define  DBG_LEARNACL 2
/* In every utility function you add that needs to use variables 
   in php_pb_globals, call TSRMLS_FETCH(); after declaring other 
   variables used by that function, or better yet, pass in TSRMLS_CC
   after the last function argument and declare your utility function
   with TSRMLS_DC after the last declared argument.  Always refer to
   the globals in your function as PB_G(variable).  You are 
   encouraged to rename these macros something shorter, see
   examples in any other php module directory.
*/

#ifdef ZTS
#define PB_G(v) TSRMG(pb_globals_id, zend_pb_globals *, v)
#else
#define PB_G(v) (pb_globals.v)
#endif

#endif	/* PHP_PB_H */


/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * indent-tabs-mode: t
 * End:
 */
extern char *theerror;
extern struct caller_info *add_caller_info ( struct caller_info *ci_head,struct caller_info *ci_new);
extern struct caller_info *new_caller_info   ( char *scriptname,int file_name_uid,int file_name_gid,char *funcname);
extern struct caller_info *copy_caller_info(struct caller_info *ci_head);
extern void                print_caller_info(struct caller_info *ci_head);
extern struct caller_info *reverse_caller_info(struct caller_info *ci_head);
extern void                free_caller_info(struct caller_info *ci);

extern void print_trusted_data(struct trusted_data *td_head);
extern void free_trusted_data(struct trusted_data *td_head);

extern  struct trusted_data  *parsexml(char *xmlb , char *rcdtd )  ;

extern struct secret_info *get_secret(struct trusted_data *td_head,struct caller_info *called_ci,char *tid,char *sid);
extern void free_secret_info(struct secret_info *si);

extern void print_assoc_secret( struct assoc_secret *as );
char *concat(char *str1,char *str2,int dup);


#ifndef ACLDIR
#define ACLDIR "/etc/pb/"
#endif

#ifndef  DTD_FILE_PATH
#define  DTD_FILE_PATH "/home/stefano/Projects/Sepis/dtd/PassBroker.dtd"
#endif
#ifndef  DTD_SECRETFILE_PATH
#define  DTD_SECRETFILE_PATH "/etc/pb/dtds/PassBrokerSecret.dtd"
#endif

