#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <grp.h>
#include <pwd.h>
#include <libxml/parser.h>
#include "passbroker.h"
#include "xml_parser.h"
extern void set_error(char *m);
/*
   returns user owner  name
*/
char *get_uowner_name_by_id(int uid)
{
 struct passwd *s_passwd;
 char *uownername;
 if(uid>0)
 {
  s_passwd=getpwuid(uid);
  if(s_passwd==NULL)
  { 
    set_error("owner does not exist");
    return NULL;
   }
   uownername=strdup( s_passwd->pw_name);
   free(s_passwd);
   return  uownername;
 }else
 return NULL;
}

/*
    returns user owner id
*/
int get_uowner_id_by_name(char *uownername)
{
 struct passwd *s_passwd;
  
 if(uownername !=NULL)
 {
  s_passwd=getpwnam(uownername);
  if(s_passwd==NULL)
  {
     set_error("owner does not exist");
      return -1;
  }

  return s_passwd->pw_uid;
 }else
 return -1;
}

/*
    returns group owner id
*/
int get_gowner_id_by_name(char *gownername)
{
  struct group *s_passwd;
 
 if(gownername !=NULL)
 {
   s_passwd=getgrnam( gownername );
   if(s_passwd==NULL)
   { 
    set_error("gowner does not exist");
      return -1;
   }

   return s_passwd->gr_gid;
   }else
 return -1;
}

char *get_gowner_name_by_id(int gid)
{
 struct  group *s_passwd;
 char *gownername;

 if(gid>=0)
 {
   s_passwd=getgrgid( gid);
   if(s_passwd==NULL)
   { 
     set_error("gowner does not exist");
     return NULL;
   }
   gownername=strdup( s_passwd->gr_name);
   free(s_passwd);
   return  gownername;

 }else
 return NULL;
}

/**
 check_file checks if a filename is a 'good' filename
 if not, it sanitize it and returns 1 or 0;
*/
char *check_file(struct  acl_nodes *acl_node)
{
  char *tmpname; 
  struct stat statbuf;
  int filenamelen;
  if(acl_node->secret_filename){
  filenamelen=strlen(acl_node->secret_filename);
    if( acl_node->secret_filename[filenamelen-1]!='l' && acl_node->secret_filename[filenamelen-2]!='m' && acl_node->secret_filename[filenamelen-3]!='x'  )
    {
      set_error("file is not an xml doc!");
      return NULL;
    }
 
    if(lstat(acl_node->secret_filename ,&statbuf)<0)
    {
      char msg[1024];
      snprintf(msg,1023,"sorry lstat failed on %s",acl_node->secret_filename);
      set_error(msg );
      return NULL;
    }
   if(  S_ISREG(statbuf.st_mode) && 
        (((acl_node->ufownerid)<0 ||statbuf.st_uid==(acl_node->ufownerid) )  && ((acl_node->gfownerid)<0  ||
	statbuf.st_gid==(acl_node->gfownerid))))
   { 
    tmpname= strdup(acl_node->secret_filename ); 
    return tmpname ;
   }}
   else
   {
       char msg[1024];
      snprintf(msg,1023,"sorry, error on filename: Null Pointer\n");
      set_error(msg );
      return NULL;
     
   }
   set_error("some problem with permissions!");
   return NULL;
}
