/****************************************************************************
** $Id: $
**
** Definition of TRUSTED_DATA
**
** Created : 030904
**
** Copyright (C) 2003  Stefano Di Paola All rights reserved.
**
** This file is part of the readdbp file package.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** 
** Contact stefano.dipaola1@tin.it if any conditions of this licensing are
** not clear to you.
** 
**********************************************************************/  
#ifndef MIN
#define MIN(a,b) (((a)<(b))?(a):(b))
#endif
#ifndef  __XML_PARSER_H__
#include <libxml/parser.h>
#include <libxml/xpath.h>
#include <libxml/xmlerror.h>
#include "zend_errors.h"
#endif

struct acl_nodes
{
  xmlNodePtr node;
  xmlDocPtr secretDoc;
  xmlNodePtr ciNode;
  char *tid;
  char *secret_filename;
  int ufownerid;
  int gfownerid;
  struct caller_info *ci;
  struct acl_nodes *next;
};

void parse_rc(char  *xmlbuf,char  *tid,struct trusted_data *t_d);
void parse_secret(struct trusted_data *t_d);

extern void free_trusted_data(struct trusted_data *t_d);
extern struct caller_info *add_caller_info ( struct caller_info *ci_head,struct caller_info *ci_new);
extern struct caller_info *new_caller_info   ( char *scriptname,int file_name_uid,int file_name_gid,char *funcname);
extern struct caller_info *add_caller_info_from_tail( struct caller_info *ci_head,char *scriptname,int file_name_uid,int file_name_gid,char *funcname);
extern void                print_caller_info(struct caller_info *ci_head);
extern struct caller_info *reverse_caller_info(struct caller_info *ci_head);
extern void                free_caller_info(struct caller_info *ci);

extern struct trusted_secret *add_trusted_secret( struct trusted_secret *ts_head,struct trusted_secret  *ts_node);
extern struct trusted_secret *new_trusted_secret(char *sid,char *secret_info,struct caller_info *ci);
extern void                   free_trusted_secret(struct trusted_secret *ts);

extern struct trusted_data *add_trusted_data( struct trusted_data *ts_head,struct trusted_data  *ts_node);
extern struct trusted_data * new_trusted_data( char *tid,struct trusted_secret *ts_head,struct caller_info *ci_head );
extern void free_trusted_data(struct trusted_data *td);

extern struct secret_info *new_secret_info( char *tid,char *sid ,char *sinfo);
extern struct  secret_info *add_secret_info( struct  secret_info *si_head,struct  secret_info  *si_node);
extern void free_secret_info(struct secret_info *si);

extern char *get_uowner_name_by_id(int uid);
extern int get_uowner_id_by_name(char *uownername);
extern int get_gowner_id_by_name(char *gownername);
extern char *get_gowner_name_by_id(int gid);
extern char *check_file(struct  acl_nodes *acl_node);
extern void print_trusted_data(struct trusted_data *td_head);
extern struct caller_info *copy_caller_info(struct caller_info *ci_head);
extern struct assoc_secret *  new_assoc_secret (char *name,char *value);
extern struct assoc_secret * add_assoc_secret( struct assoc_secret *as_head,struct assoc_secret *as_node);
extern void print_assoc_secret(struct assoc_secret *as_head);
extern void free_assoc_secret(struct assoc_secret *as);

#ifndef  DTD_SECRETFILE_PATH
#define  DTD_SECRETFILE_PATH "/etc/pb/dtds/PassBrokerSecret.dtd"
#endif

#define  ACL_DIR "/etc/pb/"
